#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "winlistres.h"

int number_of_names=0, x=0;
char temp[80];
int indi=0;
char indi_name[80];
char last_action[80];
FILE *fp;


HINSTANCE hInst;	// Instance handle
HWND hwndMain;		//Main window handle

HWND hwndToolBar;
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

// Global Variables for the status bar control.

HWND  hWndStatusbar;

void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags)
{
    SendMessage(hWndStatusbar, SB_SETTEXT, partNumber | displayFlags, (LPARAM)lpszStatusString);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{
     number_of_names=-1;

do{
  fgets(temp,80,fp);

    for(x=0;x<50;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      indi=atoi(temp);
  }



  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
     ///widget_show(namelist[number_of_names]);
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(indi >=1){
        sprintf(indi_name,"%04d %s",indi,temp);
     }
     else{
        sprintf(indi_name,"Submitted by: %s",temp);
     }

     ///entry_set_text(ENTRY(namelist[number_of_names]),indi_name);
     ///entry_set_has_frame(ENTRY(namelist[number_of_names]),FALSE);
  }

  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){   ///2 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}

     if(last_action[0]=='B' && last_action[1]=='I'){
       sprintf(indi_name, "%s (%s -",indi_name,temp);
       //entry_set_text(ENTRY(namelist[number_of_names]),indi_name);
       ///color.red =   44110;
       ///color.blue =  44110;
       ///color.green = 65535;
       ///widget_modify_base(ENTRY(namelist[number_of_names]),STATE_NORMAL,&color);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       sprintf(indi_name, "%s %s)",indi_name,temp);
       ///entry_set_text(ENTRY(namelist[number_of_names]),indi_name);
       ///color.red =   65535;
       ///color.blue =      0;
       ///color.green = 65535;
       ///widget_modify_base(ENTRY(namelist[number_of_names]),STATE_NORMAL,&color);
     }

  }
  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H'){ //1 CHAN
     strcpy(last_action,"CHAN");
  }

}while(temp[0] !='0' || temp[2] !='T');

fclose(fp);

}




LRESULT MsgMenuSelect(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    static char szBuffer[256];
    UINT   nStringID = 0;
    UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
    UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
    HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

    szBuffer[0] = 0;                            // First reset the buffer
    if (fuFlags == 0xffff && hMenu == NULL)     // Menu has been closed
        nStringID = 0;

    else if (fuFlags & MFT_SEPARATOR)           // Ignore separators
        nStringID = 0;

    else if (fuFlags & MF_POPUP)                // Popup menu
    {
        if (fuFlags & MF_SYSMENU)               // System menu
            nStringID = IDS_SYSMENU;
        else
            // Get string ID for popup menu from idPopup array.
            nStringID = 0;
    }  // for MF_POPUP
    else                                        // Must be a command item
        nStringID = uCmd;                       // String ID == Command ID

    // Load the string if we have an ID
    if (0 != nStringID)
        LoadString(hInst, nStringID, szBuffer, sizeof(szBuffer));
    // Finally... send the string to the status bar
    UpdateStatusBar(szBuffer, 0, 0);
    return 0;
}


void InitializeStatusBar(HWND hwndParent,int nrOfParts)
{
    const int cSpaceInBetween = 8;
    int   ptArray[40];   // Array defining the number of parts/sections
    RECT  rect;
    HDC   hDC;

   /* * Fill in the ptArray...  */

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right;
    //---TODO--- Add code to calculate the size of each part of the status
    // bar here.

    ReleaseDC(hwndParent, hDC);
    SendMessage(hWndStatusbar,
                SB_SETPARTS,
                nrOfParts,
                (LPARAM)(LPINT)ptArray);

    UpdateStatusBar("Ready", 0, 0);
    //---TODO--- Add code to update all fields of the status bar here.
    // As an example, look at the calls commented out below.

//    UpdateStatusBar("Cursor Pos:", 1, SBT_POPOUT);
//    UpdateStatusBar("Time:", 3, SBT_POPOUT);
}


static BOOL CreateSBar(HWND hwndParent,char *initialText,int nrOfParts)
{
    hWndStatusbar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,
                                       initialText,
                                       hwndParent,
                                       IDM_STATUSBAR);
    if(hWndStatusbar)
    {
        InitializeStatusBar(hwndParent,nrOfParts);
        return TRUE;
    }

    return FALSE;
}

int GetFileName(char *buffer,int buflen)
{
	char tmpfilter[40];
	int i = 0;
	OPENFILENAME ofn;

	memset(&ofn,0,sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hInstance = GetModuleHandle(NULL);
	ofn.hwndOwner = GetActiveWindow();
	ofn.lpstrFile = buffer;
	ofn.nMaxFile = buflen;
	ofn.lpstrTitle = "Open";
	ofn.nFilterIndex = 2;
	ofn.lpstrDefExt = "ged";
	strcpy(buffer,"*.ged");
	strcpy(tmpfilter,"All files,*.*,GEDCOM Files,*.ged");
	while(tmpfilter[i]) {
		if (tmpfilter[i] == ',')
			tmpfilter[i] = 0;
		i++;
	}
	tmpfilter[i++] = 0; tmpfilter[i++] = 0;
	ofn.Flags = 539678;
	ofn.lpstrFilter = tmpfilter;
	return GetOpenFileName(&ofn);

}

static BOOL InitApplication(void)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszClassName = "winlistWndClass";
	wc.lpszMenuName = MAKEINTRESOURCE(IDMAINMENU);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	if (!RegisterClass(&wc))
		return 0;

	// ---TODO--- Call module specific initialization routines here

	return 1;
}

HWND CreatewinlistWndClassWnd(void)
{
	return CreateWindow("winlistWndClass","win32 GEDCOM List",
		WS_MINIMIZEBOX|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_MAXIMIZEBOX|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_THICKFRAME,
		CW_USEDEFAULT,0,CW_USEDEFAULT,0,NULL,NULL,hInst,NULL);
}

BOOL _stdcall AboutDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
		case WM_CLOSE:
			EndDialog(hwnd,0);
			return 1;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					EndDialog(hwnd,1);
					return 1;
			}
			break;
	}
	return 0;
}


void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{	char buffer[MAX_PATH];

	switch(id) {
		// ---TODO--- Add new menu commands here

		case IDM_ABOUT:
			 DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwndMain,AboutDlg);
			 break;

		case SHOW_INDI:
		     DialogBox(hInst,MAKEINTRESOURCE(DLG_0900),hwndMain,AboutDlg);
			 break;

		case IDM_OPEN:
		     GetFileName(buffer,sizeof(buffer));
		     break;

		case IDM_EXIT:
		     PostMessage(hwnd,WM_CLOSE,0,0);
		     break;
	}
}


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch (msg) {

	case WM_SIZE:
		SendMessage(hWndStatusbar,msg,wParam,lParam);
		SendMessage(hwndToolBar,msg,wParam,lParam);
		InitializeStatusBar(hWndStatusbar,1);
		break;
	case WM_MENUSELECT:
		return MsgMenuSelect(hwnd,msg,wParam,lParam);
	case WM_COMMAND:
		HANDLE_WM_COMMAND(hwnd,wParam,lParam,MainWndProc_OnCommand);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0;
}

#define NUM_TOOLBAR_BUTTONS		3

HWND CreateAToolBar(HWND hwndParent)
{
	HWND hwndTB;
	TBADDBITMAP tbab;
	TBBUTTON tbb[NUM_TOOLBAR_BUTTONS];
	int index1,index2,index3;

	// Ensure that the common control DLL is loaded.
	InitCommonControls();

	// Create a toolbar that the user can customize and that has a
	// tooltip associated with it.
	hwndTB = CreateWindowEx(0, TOOLBARCLASSNAME, (LPSTR) NULL,
	    WS_CHILD|WS_BORDER|CCS_ADJUSTABLE,0, 0, 0, 0, hwndParent, (HMENU) ID_TOOLBAR, hInst, NULL);

	// Send the TB_BUTTONSTRUCTSIZE message, which is required for
	// backward compatibility.
	SendMessage(hwndTB, TB_BUTTONSTRUCTSIZE,(WPARAM) sizeof(TBBUTTON), 0);

	// Add the bitmap containing button images to the toolbar.
	tbab.hInst = HINST_COMMCTRL;
	tbab.nID   = IDB_STD_LARGE_COLOR;
	SendMessage(hwndTB, TB_ADDBITMAP, (WPARAM) NUM_TOOLBAR_BUTTONS,(LPARAM) &tbab);

	// clean memory before using it
	memset(tbb,0,sizeof tbb);

	// Add the strings
    index1 = SendMessage(hwndTB,TB_ADDSTRING,0,(LPARAM)"Close");
	index2 = SendMessage(hwndTB,TB_ADDSTRING,0,(LPARAM)"Open");
	index3 = SendMessage(hwndTB,TB_ADDSTRING,0,(LPARAM)"List by Data");

    tbb[0].iString = index1;
	tbb[1].iString = index2;
    tbb[2].iString = index3;

    // Button "Close"
	tbb[0].iBitmap = 400;
	tbb[0].idCommand = IDM_EXIT;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;

    // Button "Open"
	tbb[1].iBitmap = STD_FILEOPEN;
	tbb[1].idCommand = IDM_OPEN;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;

	// show INDI list
	tbb[2].iBitmap = STD_PROPERTIES;
	tbb[2].idCommand = SHOW_INDI;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;


	//show buttons
	SendMessage(hwndTB,TB_ADDBUTTONS,3,(LPARAM)&tbb); //3 for 3 buttons
	//show window
	ShowWindow(hwndTB,SW_SHOW);
	return hwndTB;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	HANDLE hAccelTable;

	hInst = hInstance;
	if (!InitApplication())
		return 0;
	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	if ((hwndMain = CreatewinlistWndClassWnd()) == (HWND)0)
		return 0;
	CreateSBar(hwndMain,"Ready",1);
	hwndToolBar = CreateAToolBar(hwndMain);
	ShowWindow(hwndMain,SW_SHOW);
	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateAccelerator(msg.hwnd,hAccelTable,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}
