// markdata2.c
//(c) 2007-2017
//written by Michael Gibson
//Under the GPL lic

#include <stdio.h>
#include <string.h>


////////////////////////////////////////
//mark_indi(void)
///////////////////////////////////
void mark_indi(void){

  FILE *fp2;
  char temp2[30];
  char check_string[30];

  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }

  indi_name_m=0;
  indi_deat_date_m=0;
  indi_deat_plac_m=0;
  indi_deat_note_m=0;
  indi_buri_date_m=0;
  indi_buri_plac_m=0;
  indi_buri_note_m=0;
  indi_crem_date_m=0;
  indi_crem_plac_m=0;
  indi_crem_note_m=0; 

  do{
    temp2[0]='x';
    fgets(temp2,30,fp2);
    //0009:name:1:z00001.ged
    sprintf(check_string,"%04d:name:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_name_m=1;

    sprintf(check_string,"%04d:dd__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_date_m=1;

    sprintf(check_string,"%04d:dp__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_plac_m=1;

    sprintf(check_string,"%04d:dn__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_note_m=1;


  }while(temp2[0]!='x');

fclose(fp2);
}

/////////////////////////////////////////////////////
//mark_name(void)
////////////////////////////////////////////////////
void mark_name(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:name:1:z00001.ged
    sprintf(check_string1,"%04d:name:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:name:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_name_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_name,"images/update2.xpm");
    entry_found=1;
    indi_name_m=1;
  }
  if(indi_name_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_name,"images/update.xpm");
    indi_name_m=0;
  }
fclose(fp2);
}











/////////////////////////////////////////////////////
//mark_deat_date(void)
////////////////////////////////////////////////////
void mark_deat_date(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:dd__:1:z00001.ged
    sprintf(check_string1,"%04d:dd__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:dd__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='d' && temp2[x][6]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_deat_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_deat_date,"images/update2.xpm");
    entry_found=1;
    indi_deat_date_m=1;
  }
  if(indi_deat_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_deat_date,"images/update.xpm");
    indi_deat_date_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_deat_note(void)
////////////////////////////////////////////////////
void mark_deat_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:dn__:1:z00001.ged
    sprintf(check_string1,"%04d:dn__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:dn__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='d' && temp2[x][6]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_deat_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_deat_note,"images/update2.xpm");
    entry_found=1;
    indi_deat_note_m=1;
  }
  if(indi_deat_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_deat_note,"images/update.xpm");
    indi_deat_note_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_buri_date(void)
////////////////////////////////////////////////////
void mark_buri_date(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:buda:1:z00001.ged
    sprintf(check_string1,"%04d:buda:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:buda:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u' && temp2[x][7]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_date,"images/update2.xpm");
    entry_found=1;
    indi_buri_date_m=1;
  }
  if(indi_buri_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_date,"images/update.xpm");
    indi_buri_date_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_buri_plac(void)
////////////////////////////////////////////////////
void mark_buri_plac(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:bupl:1:z00001.ged
    sprintf(check_string1,"%04d:bupl:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:bupl:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_plac_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_plac,"images/update2.xpm");
    entry_found=1;
    indi_buri_plac_m=1;
  }
  if(indi_buri_plac_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_plac,"images/update.xpm");
    indi_buri_plac_m=0;
  }
fclose(fp2);
}
///////////////////
// buri note mark
//////////////////
void mark_buri_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:buno:1:z00001.ged
    sprintf(check_string1,"%04d:buno:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:buno:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u'&& temp2[x][7]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_note,"images/update2.xpm");
    entry_found=1;
    indi_buri_note_m=1;
  }
  if(indi_buri_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_note,"images/update.xpm");
    indi_buri_note_m=0;
  }
fclose(fp2);
}

